SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'content catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:36'!
createWithcatalogue: aCatalogue
 	| cartToReturn |
	cartToReturn := self new.
	^cartToReturn initializeWithCatalogue: aCatalogue. ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:07'!
add: aBook
	( catalogue includes: aBook ) ifFalse: [self error:'$NOT IN CATALOGUE$'.].
	^content add: aBook ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:31'!
hasItem: aBook
	^ content includes: aBook.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:46'!
hasItemInCatalog:anItem
| newSet |
newSet:= Set new.
newSet add:anItem.
^ catalogue includesAll: newSet.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:08'!
initialize 
	catalogue := Set new.
	content:= Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
initializeWithCatalogue: aCatalogue
	catalogue := aCatalogue.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:43'!
isEmpty
	^content size = 0.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 19:23'!
numberofCartElements
	^ content size.! !

Object subclass: #Cashier
	instanceVariableNames: 'priceCatalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:36'!
checkout: aCart
	(aCart isEmpty )ifTrue:[self error: ' $CANNOT CHECKOUT AN EMPTY CART$']
	""! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:33'!
initialize 
priceCatalog := Dictionary new.! !

Object subclass: #TarjetaDeCreditoREPRESENTARPLASTICO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Ventas
	instanceVariableNames: 'libroDeVentas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'FacundoPippia 5/29/2013 20:56'!
test01newCartMustBeEmptyOnCreation

	| aCart |
	aCart := Cart new.
	self assert: aCart isEmpty.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'TuVieja 5/29/2013 20:34'!
test03cartMustNotBeEmptyAfterAddingABook
	
	|aCart aCatalog|
	
	aCart := Cart new.
	aCatalog:= Set new.
	aCatalog add: '8709427699867'.
	aCart initializeWithCatalogue: aCatalog.
	aCart add: '8709427699867'.
	self deny: aCart isEmpty.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'FacundoPippia 5/29/2013 21:10'!
test04cannotAddBookIfItIsNotPresentInCatalogue
	
	|aCart aBook|
	
	aCart := Cart new.
	
	aBook := 'LOTR'.
	
	
	self should: [ aCart add: aBook. self assert: (aCart hasItem: aBook) .] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = '$NOT IN CATALOGUE$' ].

	! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'FacundoPippia 5/29/2013 21:12'!
test05OnlyAddedBookMustBeInCartAfterAddition
	
	|aCart aBook aCatalog |
	
	aCart := Cart new.
	aBook := 'LOTR'.
	aCatalog:= Set new.
	aCatalog add: aBook.
	aCart initializeWithCatalogue: aCatalog.
	aCart add: aBook.

	self assert: (aCart hasItem: aBook).
	self assert:( aCart numberofCartElements = 1 ).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:24'!
test05cannotCheckoutAnEmptyCart
	| aCart aCashier |
	aCart := Cart new.
	aCashier := Cashier new.
	self should: [ aCashier checkout: aCart.] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = ' $CANNOT CHECKOUT AN EMPTY CART$' ].
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:27'!
test06cashierPrizeCalculationMustBeCorrect
	"NEED FOR BETTER NAME"
	| aCart aCashier aCatalog aBook |
	aBook:= 'La Republica'.
	aCatalog := Set new.
	aCatalog add: aBook.
	aCart := Cart new.
	aCart initializeWithCatalogue: aCatalog.
	aCashier := Cashier new.
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:38'!
test06onCheckoutEveryItemInCartMustBeonPriceDictionary
	"NEED FOR BETTER NAME"
	| aCart aCashier aCatalog aBook |
	aBook:= 'La Republica'.
	aCatalog := Set new.
	aCatalog add: aBook.
	aCart := Cart new.
	aCart initializeWithCatalogue: aCatalog.
	aCashier := Cashier new.
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:51'!
test07cashierPriceCalculationMustBeCorrect
	"NEED FOR BETTER NAME ... el carro tiene un libro de10 pess y el cajero me cobra 10 pesos" 
	| aCart aCashier aCatalog aBook |
	aBook:= 'La Republica'.
	aCatalog := Set new.
	aCatalog add: aBook.
	aCart := Cart new.
	aCart initializeWithCatalogue: aCatalog.
	aCashier := Cashier new.
	! !
